/*------------------------------------------------------------
 * TEST1.c - Practice for Position Computation.
 *------------------------------------------------------------*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

/*------------------------------------------------------------
 * 萔E\̂̒`
 *------------------------------------------------------------*/
/* _^ */
typedef	int	bool;
#define	TRUE	1
#define	FALSE	0

/* WGS-84萔 */
#define	PI		3.1415926535898		/* ~iIS-GPS-200j */
#define	C		2.99792458e8		/* [m/s] */
#define	MUe		3.986005e14			/* nd͒萔[m^3/s^2] */
#define	dOMEGAe	7.2921151467e-5		/* n]px[rad/s] */
#define	Re		6378137.0			/* na[m] */
#define	Fe		(1.0/298.257223563)	/* n̝G */

/* px̕ϊ */
#define	rad_to_deg(rad)		((rad)/PI*180.0)
#define	deg_to_rad(deg)		((deg)/180.0*PI)
#define	rad_to_sc(rad)		((rad)/PI)
#define	sc_to_rad(sc)		((sc)*PI)

/* 舵s̑傫 */
#define	MAX_N				16		/* ϑq̏ */
#define	MAX_M				4		/* m̍ő吔 */
#define	MAX_PRN				32		/* qԍ̏ */

/*  */
#define	SECONDS_DAY			(3600L*24L)
#define	SECONDS_WEEK		(3600L*24L*7L)

/* \\ */
typedef struct {
	int		week;		/* Tԍ */
	double	sec;		/* T߂̌oߎ[s] */
}	wtime;

/* W\\ */
typedef struct {
	double	x;			/* XW[m] */
	double	y;			/* YW[m] */
	double	z;			/* ZW[m] */
}	posxyz;
#define	SQ(x)			((x)*(x))
#define	DIST(a,b)		sqrt(SQ(a.x-b.x)+SQ(a.y-b.y)+SQ(a.z-b.z))

/* oܓx\\ */
typedef struct {
	double	lat;		/* ܓx[rad] */
	double	lon;		/* ox[rad] */
	double	hgt;		/* xiȉ~̍j[m] */
}	posblh;

/* ENUW\\ */
typedef struct {
	double	e;			/* East[m] */
	double	n;			/* North[m] */
	double	u;			/* Up[m] */
}	posenu;

/*------------------------------------------------------------
 * ʌvZ
 *------------------------------------------------------------*/

/*------------------------------------------------------------
 * inverse_matrix() - tsvZ
 *------------------------------------------------------------
 *  void inverse_matrix(a,n);
 *    double a[][]; ̍s(tsŏ㏑)
 *    int m;        s̎(1`MAX_M)
 *------------------------------------------------------------
 *   ^ꂽs̋ts߂. ʂɂA̍s
 * ㏑.
 *------------------------------------------------------------*/
static void inverse_matrix(double a[MAX_M][MAX_M],int m)
{
	int		i,j,k;
	double	b[MAX_M][MAX_M+MAX_M];

	/* p̍s */
	for(i=0;i<m;i++) {
		for(j=0;j<m;j++) {
			b[i][j]=a[i][j];
			if (i==j) b[i][j+m]=1.0; else b[i][j+m]=0.0;
		}
	}

	/* KEX̏@ */
	for(i=0;i<m;i++) {
		/* isb[i][i]ŐK */
		if (fabs(b[i][i])<=1E-10) {
			fprintf(stderr,"Cannot inverse matrix.\n");
			exit(2);
		}
		for(j=m+m-1;j>=i;j--) {
			b[i][j]/=b[i][i];
		}

		/* ̍s̑i */
		for(k=0;k<m;k++) if (k!=i) {
			for(j=m+m-1;j>=i;j--) {
				b[k][j]-=b[k][i]*b[i][j];
			}
		}
	}

	/* ̍stsŏ㏑ */
	for(i=0;i<m;i++) {
		for(j=0;j<m;j++) {
			a[i][j]=b[i][j+m];
		}
	}
}

/*------------------------------------------------------------
 * compute_solution() - ŏ@ŕ
 *------------------------------------------------------------
 *  void compute_solution(G,dr,wgt,dx,cov,n,m);
 *    double G[][];   fUCs(n~m)
 *    double dr[];    ̉E(n)
 *    double wgt[];   d݌W(n)/NULL:d݂Ȃ
 *    double dx[];    ̉ŏ㏑(m)
 *    double cov[][]; Usŏ㏑(m~m)
 *    int n;          ̐
 *    int m;          m̐
 *------------------------------------------------------------
 *   ^ꂽŏ@ɂ. d݂svȏꍇ
 *  wgt=NULL ƂČĂяo.
 *------------------------------------------------------------*/
void compute_solution(double G[MAX_N][MAX_M],double dr[MAX_N],
	double wgt[MAX_N],double dx[MAX_M],double cov[MAX_M][MAX_M],
	int n,int m)
{
	int		i,j,k;
	double	w,a[MAX_M][MAX_N];

	/* GtG߂ */
	for(i=0;i<m;i++) {
		for(j=0;j<m;j++) {
			cov[i][j]=0.0;
			for(k=0;k<n;k++) {
				if (wgt==NULL) w=1.0; else w=wgt[k];
				cov[i][j]+=G[k][i]*G[k][j]*w;
			}
		}
	}

	/* ts߂iꂪUsCƂȂj */
	inverse_matrix(cov,m);

	/* Gt */
	for(i=0;i<m;i++) {
		for(j=0;j<n;j++) {
			a[i][j]=0.0;
			for(k=0;k<m;k++) {
				if (wgt==NULL) w=1.0; else w=wgt[j];
				a[i][j]+=cov[i][k]*G[j][k]*w;
			}
		}
	}

	/* drƉɂȂ */
	for(i=0;i<m;i++) {
		dx[i]=0.0;
		for(k=0;k<n;k++) {
			dx[i]+=a[i][k]*dr[k];
		}
	}
}

/*------------------------------------------------------------
 * main() - C
 *------------------------------------------------------------*/
#define	LOOP	8
#define	SATS	5
static posxyz	position[SATS]={
	{-13897607.6294,-10930188.6233,19676689.6804},	/* PRN 05 */
	{-17800899.1998,15689920.8120,11943543.3888},	/* PRN 14 */
	{-1510958.2282,26280096.7818,-3117646.1949},	/* PRN 16 */
	{-12210758.3517,20413597.0201,-11649499.5474},	/* PRN 22 */
	{-170032.6981,17261822.6784,20555984.4061},		/* PRN 25 */
};
static double	range[SATS]={
	23634878.5219,	/* PRN 05 */
	20292688.3557,	/* PRN 14 */
	24032055.0372,	/* PRN 16 */
	24383229.3740,	/* PRN 22 */
	22170992.8178,	/* PRN 25 */
};

void main(int argc,char **argv)
{
	int		i,n,loop;
	double	r,G[MAX_N][MAX_M],dr[MAX_N],dx[MAX_M];
	double	sol[MAX_M],cov[MAX_M][MAX_M];
	posxyz	satpos;

	/*  */
	for(i=0;i<MAX_M;i++) sol[i]=0.0;

	/* ߂郋[v */
	for(loop=0;loop<LOOP;loop++) {
		n=SATS;
		for(i=0;i<n;i++) {
			satpos	=position[i];

			/* fUCs */
			r		=sqrt((satpos.x-sol[0])*(satpos.x-sol[0])
						+(satpos.y-sol[1])*(satpos.y-sol[1])
						+(satpos.z-sol[2])*(satpos.z-sol[2]));
			G[i][0]	=(sol[0]-satpos.x)/r;
			G[i][1]	=(sol[1]-satpos.y)/r;
			G[i][2]	=(sol[2]-satpos.z)/r;

			/* [̏C */
			dr[i]	=range[i]-r;
		}

		/*  */
		compute_solution(G,dr,NULL,dx,cov,n,3);

		/* lɉ */
		for(i=0;i<3;i++) {
			sol[i]+=dx[i];
		}

		/* ro߂o͂ */
		printf("LOOP %d: X=%.3f, Y=%.3f, Z=%.3f\n",
			loop+1,sol[0],sol[1],sol[2]);
	}

	exit(0);
}

